;***************************************************************
;Programa vieno failo simboliu kodus uzraso i kita faila Hex formatu
;Failu pavadinimai perduodami komandine eilute
;***************************************************************
.model small
skBufDydis	EQU 20			;konstanta skBufDydis (lygi 20) - skaitymo buferio dydis
raBufDydis	EQU 60		;konstanta raBufDydis= minimum 3 x skBufdydis
.stack 100h
.data
	help_mssg	db '===================================================',10,13
				db 'Programa vieno failo simbolius uzraso i kita faila',10,13
				db 'sesioliktainiais skaitmenimis.',10,13
				db '- - - - - - - - - - - - - - - - - - - - - - - - - -',10,13
				db 'Programai BUTINA perduot du parametrus-failu vardus! ',10,13
				db 'PIRMAS parametras: DUOMENU failo pavadinimas,',10,13
				db 'ANTRAS parametras: REZULTATU failo pavadinimas',10,13
				db '---------------------------------------------------',10,13
				db 'Atliko:  MIROSLAV TOMASEVIC MIF IT 3',10,13
				db '            2010 lapkritis',10,13
				db '===================================================',10,13,'$'
	sekme_mssg	db 'Operacijos atliktos sekmingai',10,13,'$'
	duom 	db 50 dup(0) 
	rez		db 50 dup(0)
	skBuf	db skBufDydis dup (?)	;skaitymo buferis
	raBuf	db raBufDydis dup (?)	;raymo buferis
	dFail	dw ?			;vieta, skirta saugoti duomenu failo deskriptoriaus numeri ("handle")
	rFail	dw ?			;vieta, skirta saugoti rezultato failo deskriptoriaus numeri
	kiek	dw 0
.code
  pradzia:
	MOV	ax, @data		;reikalinga kiekvienos programos pradzioj
	MOV	ds, ax			;reikalinga kiekvienos programos pradzioj
	; =================================================================================
	; skaitom parametrus
	CMP byte ptr[ES:80h],0	; jei nera parametru-pagalba+isejimas
	JE jumpParam
	JMP nextParam
	JumpParam:
	JMP help_pabaiga
	nextParam:
	
	XOR cx,cx
	MOV cl,byte ptr[ES:80h]	; [ES:80h] saugomas parametru eilutes ilgis
	DEC cl
	DEC cl
	MOV SI,82h
	MOV DI,offset duom
	; skaitom pirma parametra
	paramCiklas1:
		CMP byte ptr[ES:SI],20h
		JE paramToliau
		XOR ax,ax
		MOV al,byte ptr[ES:SI]
		MOV byte ptr[DS:DI],Al
		INC DI
		INC SI
		DEC cx
		CMP cx,0
		JE paramToliau
		JMP paramCiklas1
	; skaitom antra parametra
	paramToliau:
	INC SI
	MOV DI,offset rez
	paramCiklas2:
		CMP byte ptr[ES:SI],20h
		JE JumpParam2
		JMP nextParam2
		JumpParam2:
		JMP help_pabaiga
		NextParam2:
		
		XOR ax,ax
		MOV al,byte ptr[ES:SI]
		MOV byte ptr[DS:DI],al
		INC DI
		INC SI
		DEC cx
		CMP cx,0
		JE paramToliau2
		JMP paramCiklas2
	paramToliau2:
; ========================================================================
;*****************************************************
;Duomenu failo atidarymas skaitymui
;*****************************************************
	MOV	ah, 3Dh				;21h pertraukimo failo atidarymo funkcijos numeris
	MOV	al, 00				;00 - failas atidaromas skaitymui
	MOV	dx, offset duom			;vieta, kur nurodomas failo pavadinimas, pasibaigiantis nuliniu simboliu
	INT	21h				;failas atidaromas skaitymui
	JNC	next1	;jei atidarant fail skaitymui vyksta klaida, nustatomas carry flag                      
	JMP klaidaAtidarantSkaitymui
	next1:
	MOV	dFail, ax			;atmintyje isisaugom duomen failo deskriptoriaus numer

;*****************************************************
;Rezultato failo sukurimas ir atidarymas raymui
;*****************************************************
	MOV	ah, 3Ch				;21h pertraukimo failo sukrimo funkcijos numeris
	MOV	cx, 0				;kuriamo failo atributai
	MOV	dx, offset rez			;vieta, kur nurodomas failo pavadinimas, pasibaigiantis nuliniu simboliu
	INT	21h				;sukuriamas failas; jei failas jau egzistuoja, visa jo informacija itrinama
	JC	sokt2		;jei kuriant fail skaitymui vyksta klaida, nustatomas carry flag
	JMP next2
	sokt2:
	JMP klaidaAtidarantRasymui
	next2:
	MOV	rFail, ax			;atmintyje isisaugom rezultato failo deskriptoriaus numer

;*****************************************************
;Duomenu nuskaitymas i failo
;*****************************************************
  skaityk:
	MOV	bx, dFail			; bx raom duomenu failo deskriptoriaus numeri
	CALL	SkaitykBuf			;ikvieciame skaitymo i failo procedura
	CMP	ax, 0				;ax raoma, kiek bait buvo nuskaityta, jeigu 0 - pasiekta failo pabaiga
	JE	uzdarytiRasymui

;*****************************************************
;Darbas su nuskaityta informacija
;*****************************************************
	MOV	cx, ax
	MOV word ptr[kiek],cx
	MOV	si, offset skBuf
	MOV	di, offset raBuf
	MOV [kiek],0
  dirbk:
	
	XOR ax,ax
	MOV al,byte ptr[SI]
	MOV dl,10h
	DIV dl
	
	;tikrinam ar registre skaitmuo 0-9
	CMP al,0
	JAE toliau1
	JMP raide1
	toliau1:
	CMP al,9
	JBE skaicius1	; jei tai skaitmuo
	raide1:			; priesingu atveju- tai raide
	ADD al,37h		; kad gaut simboio koda pridedam 37
	MOV byte ptr[DI],al
	JMP kitas
	skaicius1:
	ADD al,'0'
	MOV byte ptr[DI],al
	kitas:
	INC [kiek]
	INC DI
	CMP ah,0
	JAE toliau2
	JMP raide2
	toliau2:
	CMP ah,9
	JBE skaicius2
	raide2:
	ADD ah,37h
	MOV byte ptr[DI],ah
	JMP baigem
	skaicius2:
	ADD ah,'0'
	MOV byte ptr[DI],ah
	
	baigem:
	INC [kiek]
	INC DI
	MOV byte ptr[DI],20h
	INC [kiek]
	INC DI
	INC SI
	
	DEC cx
	CMP cx,0
	JNE dirbk
	
;*****************************************************
;Rezultato irasymas i faila
;*****************************************************
	MOV	cx, [kiek]				;cx - kiek baitu reikia irayti
	MOV	bx, rFail			;i bx iraom rezultato failo deskriptoriaus numeri
	CALL	RasykBuf			;iskvieciame rasymo i faila procedura
	CMP	ax, raBufDydis			;jeigu vyko darbas su pilnu buferiu -> i duomen failo buvo nuskaitytas pilnas buferis ->
	JE	skaityk				;-> reikia skaityti toliau
  
;*****************************************************
;Rezultato failo uzdarymas
;*****************************************************
  uzdarytiRasymui:
	MOV	ah, 3Eh				;21h pertraukimo failo uzdarymo funkcijos numeris
	MOV	bx, rFail			;i bx iraom rezultato failo deskriptoriaus numer
	INT	21h				;failo udarymas
	JC	klaidaUzdarantRasymui		;jei uzdarant faila ivyksta klaida, nustatomas carry flag
	
;*****************************************************
;Duomenu failo uzdarymas
;*****************************************************
  uzdarytiSkaitymui:
	MOV	ah, 3Eh				;21h pertraukimo failo uzdarymo funkcijos numeris
	MOV	bx, dFail			;i bx iraom duomenu failo deskriptoriaus numer
	INT	21h				;failo uzdarymas
	JC	klaidaUzdarantSkaitymui		;jei uzdarant fail ivyksta klaida, nustatomas carry flag
	MOV ah,9
	MOV DX,offset sekme_mssg
	INT 21h
	JMP pabaiga
  
  help_pabaiga:
  MOV ah,9
  MOV DX,offset help_mssg
  INT 21h
 
	pabaiga:
	MOV	ah, 4Ch				;reikalinga kiekvienos programos pabaigoj
	MOV	al, 0				;reikalinga kiekvienos programos pabaigoj
	INT	21h				;reikalinga kiekvienos programos pabaigoj

;*****************************************************
;Klaidu apdorojimas (Ivykus klaidai, isvedamas help pranesimas)
;*****************************************************
  klaidaAtidarantSkaitymui:
	;<klaidos praneimo ivedimo kodas>
	MOV ah,9
	MOV DX,offset help_mssg
	INT 21h
	JMP	pabaiga
  klaidaAtidarantRasymui:
	;<klaidos praneimo ivedimo kodas>
	MOV ah,9
	MOV DX,offset help_mssg
	INT 21h
	JMP	uzdarytiSkaitymui
  klaidaUzdarantRasymui:
	;<klaidos praneimo ivedimo kodas>
	JMP	uzdarytiSkaitymui
  klaidaUzdarantSkaitymui:
	;<klaidos praneimo ivedimo kodas>
	JMP	pabaiga

;*****************************************************
;Procedura nuskaitanti informacija i failo
;*****************************************************
PROC SkaitykBuf
;i BX paduodamas failo deskriptoriaus numeris
;i AX bus grazinta, kiek simboliu nuskaityta
	PUSH	cx
	PUSH	dx
	
	MOV	ah, 3Fh			;21h pertraukimo duomen nuskaitymo funkcijos numeris
	MOV	cl, skBufDydis		;cx - kiek bait reikia nuskaityti i failo
	MOV	ch, 0			;ivalom vyresniji cx baita
	MOV	dx, offset skBuf	;vieta, i kuria iraoma nuskaityta informacija
	INT	21h			;skaitymas i failo
	JC	klaidaSkaitant		;jei skaitant i failo ivyksta klaida, nustatomas carry flag

  SkaitykBufPabaiga:
	POP	dx
	POP	cx
	RET

  klaidaSkaitant:
	;<klaidos praneimo ivedimo kodas>
	MOV ax, 0			;Pazymime registre ax, kad nebuvo nuskaityta ne vieno simbolio
	JMP	SkaitykBufPabaiga
SkaitykBuf ENDP

;*****************************************************
;Procedura, iraanti buferi i faila
;*****************************************************
PROC RasykBuf
; BX paduodamas failo deskriptoriaus numeris
; CX - kiek bait rayti
; AX bus grazinta, kiek baitu buvo irayta
	PUSH	dx
	
	MOV	ah, 40h			;21h pertraukimo duomen raymo funkcijos numeris
	MOV	dx, offset raBuf	;vieta, i kurios raom  faila
	INT	21h			;raymas  fail
	JC	klaidaRasant		;jei raant  fail vyksta klaida, nustatomas carry flag
	CMP	cx, ax			;jei cx nelygus ax, vadinasi buvo rayta tik dalis informacijos
	JNE	dalinisIrasymas

  RasykBufPabaiga:
	POP	dx
	RET

  dalinisIrasymas:
	;<klaidos praneimo ivedimo kodas>
	JMP	RasykBufPabaiga
  klaidaRasant:
	;<klaidos praneimo ivedimo kodas>
	MOV	ax, 0			;Pazymime registre ax, kad nebuvo iraytas ne vienas simbolis
	JMP	RasykBufPabaiga
RasykBuf ENDP

END pradzia